/*
   This file is part of the MoCA video library.
   Name: Pgm2Yuv.cpp
   Copyright (C) 2004 Stephan Kopf

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: kopf@informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*! \file

 
  
   \author    Stephan Kopf
   
	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de
	
	 (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt
	 
*/


// C++ includes
#include <string>
#include <iostream>
using namespace std;

// MoCA includes
#include <IImageStream.h>
#include <OYuvVideo.h>
#include <FileList.h>


int main(int argc, char* argv[])
{
	// define file extension
	string ext  = "pgm";

	string extU = ext;
	FileHandling::upper(extU);
	cerr << argv[0] << " filename.yuv" << endl;
	cerr << "read all " << extU << " files in directory and store them as YUV video" << endl << endl;
	cerr << endl;

	// read all files in directory
	vector<FileInfo> files;
	{
		FileList flist("./", false);    
		string fs = "*.";
		fs += ext; 
		flist.process(fs, files);
	}

	// open writer
	string fn = argv[1];
	OYuvVideo writer (fn);
	Image<uint8> img;
	for (int32 i=0; i<files.size(); i++) {
		ReadImage (files[i].name, img);
		writer.write(img);
		cerr << files[i].name << " stored!" << endl;
	} // for

	return 0;
}

