/*
    GeometricFeature.cpp     calculate geometric features of an object in a binary image
    Copyright (C) 2004 Stephan Kopf

	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "GeometricFeature.h"

std::ostream& operator<< (ostream& os, const GeometricFeatureData &item)
{
	os << "circularity: " << circularity << endl;
	os << "eccentrity : " << eccentrity  << endl;
	return os;
} // operator<<


void 
GeometricFeature::process(const Image<uint8>& src, GeometricFeatureData& data) 
{

	data.circularity = 0.0;
	data.eccentrity  = 0.0;
	
	// binarize image
	Image<uint8> img;
	BinarizeFilter<uint8> bf(128);
	bg.process (src,img);
	
	// get largest object
	Image<uint8> largestObject;
	bool objectFound;
	RegionFeature<uint8> rf;
	rf.process(img, largestObject, objectFound);
	uint8 objectColor = rf.getForegroundColor();
	cerr << (int32) objectColor << endl;

WriteImage(img,"D:/test.png");
exit(1);
	if (objectFound) {

	} // if

	return;
} // process


