/*
   This file is part of the MoCA video library.
   Name: SimpleFeatures.h
   Copyright (C) 2004 Stephan Kopf

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: kopf@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef SIMPLE_FEATURES_H
#define SIMPLE_FEATURES_H

#include <GetType.h>

/*!

  This class provides a bunch of methods to return simple statistical
  data concerning an image.

*/
template <class T>
class SimpleFeatures
{
public:
    //! the default constructor
    //    SimpleFeatures();
    //! the copy constructor
    //    SimpleFeatures(const SimpleFeatures&rhs);
    //! the assignment operator
    //    SimpleFeatures& operator=(const SimpleFeatures&rhs);

    //! the default address-of operator
    // SimpleFeatures* operator&()             { return this; };
    //! the default address-of operator
    // const SimpleFeatures* operator&() const { return this; };
    //! the destructor
    //    ~SimpleFeatures();

    //! Returns the mean color of a sample block
    T getMeanColor(SampleBlock<T> &);

    //! Returns the minimum color of a sample block
    T getMinColor(SampleBlock<T> &);

    //! Returns the maximum color of a sample block
    T getMaxColor(SampleBlock<T> &);

protected:

private:

}; // SimpleFeatures

#include <SimpleFeatures.cpt>

#endif
