/*
    DrawCross.cpp     draw a cross
    Copyright (C) 2004 Stephan Kopf

	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#include<DrawCross.h>


void
DrawCross::process (const ImagePosition &p, const Color &c, const Image<uint8>& src, Image<uint8>& dest)
{
	dest=src;
	process(p, c, dest);
    return;
} // process


void
DrawCross::process (const ImagePosition &p, const Color &c, Image<uint8>& srcDest)
{
	// draw standard cross
	draw (p[DIM_X],p[DIM_Y], srcDest);

	// draw thick cross
	if (width > 1) {
		int32 left  = (width-1) / 2;
		int32 right = (width-1) - left;

		for (int32 i=1; i<=left; i++) {
			draw (p[DIM_X]-i, p[DIM_Y], srcDest);
		}
		for (int32 i=1; i<=right; i++) {
			draw (p[DIM_X]+i, p[DIM_Y], srcDest);
		}
	} // if


	return;
} // process


void 
DrawCross::draw (int32 x0,int32 y0, Image<uint8>& srcDest)
{
	// draw cross with 2 lines
	DrawLine line(c);
	line.process (
		ImagePosition(x0-halfLength,y0-halfLength), 
		ImagePosition(x0+halfLength,y0+halfLength), 
		srcDest);
	line.process (
		ImagePosition(x0+halfLength,y0-halfLength), 
		ImagePosition(x0-halfLength,y0+halfLength), 
		srcDest);

	return;
}
