/*
    DrawRectangle.cpp     draw a rectangle 
    Copyright (C) 2004 Stephan Kopf

	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include<DrawRectangle.h>


//! draw rectangle
void 
DrawRectangle::process (ImagePosition p1, ImagePosition p2, Image<uint8>& srcDest)
{
	// draw standard rectangle 
	draw (p1[DIM_X], p1[DIM_Y], p2[DIM_X], p2[DIM_Y], srcDest);

	// draw thick rectangle
	if (width > 1) {
		int32 left  = (width-1) / 2;
		int32 right = (width-1) - left;

		for (int32 i=1; i<=left; i++) {
			draw (p1[DIM_X]+i, p1[DIM_Y]+i, p2[DIM_X]-i, p2[DIM_Y]-i, srcDest);
		}
		for (int32 i=1; i<=right; i++) {
			draw (p1[DIM_X]-i, p1[DIM_Y]-i, p2[DIM_X]+i, p2[DIM_Y]+i, srcDest);
		}
	} // if
	return;
}


void
DrawRectangle::
process (ImagePosition p1, ImagePosition p2, const Image<uint8>& src, Image<uint8>& dest)
{
	dest=src;
	process (p1, p2, dest);
    return;
} // process


void 
DrawRectangle::draw (int32 x0,int32 y0,int32 x1,int32 y1, Image<uint8>& srcDest)
{
	// draw rectangle with 4 lines
    DrawLine line (c);
    line.process (ImagePosition (x0,y0),ImagePosition (x0,y1),srcDest);
    line.process (ImagePosition (x0,y1),ImagePosition (x1,y1),srcDest);
    line.process (ImagePosition (x0,y0),ImagePosition (x1,y0),srcDest);
    line.process (ImagePosition (x1,y0),ImagePosition (x1,y1),srcDest);

	return;
}
