/*
    CreateMocaPath.cpp     get default PATH for video metadata information
    Copyright (C) 2004 Stephan Kopf

	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <CreateMocaPath.h>


const string CreateMocaPath::MOCA_PATH = "_index";

std::ostream& operator<< (ostream& os, const CreateMocaPath& data)
{
	os << "file            : "<< data.file << endl;	
	os << "path and file   : "<< data.pathFile << endl;	
	os << "path            : "<< data.path << endl;	
	os << "destination path: "<< data.destinationPath << endl;	
	return os;
} // operator <<


void
CreateMocaPath::setVariables()    
{
	// remove leading or ending '"'
	string tmp=pathFile;
	while (tmp[0] == '"') tmp = tmp.substr(1);
	while (tmp[tmp.size()-1] == '"') tmp = tmp.substr(0,tmp.size()-1);
	pathFile=tmp;


	// replace '\\' with '/'
	string::size_type p;	
	for (p=0; p<pathFile.size(); p++) {
		if (pathFile[p] == '\\') {
			pathFile[p] = '/';
		} // if
	} // for
	
	p = pathFile.find_last_of ("/");
	if (p == string::npos) {
		path ="./";
		file =pathFile;
		tmp = pathFile;
	} else {
		path.assign(pathFile, 0, p+1);
		tmp.assign(pathFile, p+1, string::npos);
		file = tmp;
	} // else
	
	p = tmp.find_last_of (".");
	if (p != string::npos) {
		tmp.assign(tmp, 0, p);
	} // if
	
	destinationPath = path + tmp + MOCA_PATH + "/";

	return;
} // init


void 
CreateMocaPath::validatePath (string &name)
{
	// path contains spaces
	string::size_type pos3 = name.find(" ", 0);
	if (pos3!=string::npos) {

		// if path does not contain '"', add '"'
		pos3=0;
		pos3 = name.find("\"", 0);
		if (pos3==string::npos) {
			name = "\"" +  name +  "\"";
		} // if
	} // if

	return;
} // validatePath 




