/*
   This file is part of the MoCA video library.
   Name: IPngFormatStream.h
   Copyright (C) 2004 Oliver Schuster

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: schuster@informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*! \file



   \author    Oliver Schuster

              Lehrstuhl fuer Praktische Informatik IV
              Universitaet Mannheim
              68131 Mannheim
              Germany
              email: schuster@informatik.uni-mannheim.de

   (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt

   $Id: IPngFormatStream.h,v 1.1 2004/02/17 12:00:48 kopf Exp $

*/

#ifndef I_PNG_FORMAT_STREAM_H
#define I_PNG_FORMAT_STREAM_H

// MoCA includes
#include <MocaTypes.h>

#ifdef HAVE_LIBPNG

#include <IImageFormatStream.h>
#include <GetType.h>

// png includes
#include <png.h>

// C includes
#include <limits.h>

/*!
  pgm format specific stream
*/
template<class T>
class IPngFormatStream : public IImageFormatStream<T>
{
public:
    //! the default constructor
    IPngFormatStream(istream &is) : IImageFormatStream<T>(is) {};

    //! read an image
    void read(Image<T> &) throw (MocaException);

    //! check if "is" is of given format
    bool checkFormat();

private:
    //! our own read method
    static void user_read_fn (png_structp, png_bytep, png_size_t);
}; // IPngFormatStream

#include <IPngFormatStream.cpt>

#endif

#endif
