/*
   This file is part of the MoCA video library.
   Name: ITagStream.h
   Copyright (C) 2004 Gerald Kuehne

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: kuehne@informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*! \file



   \author    Gerald Kuehne

              Lehrstuhl fuer Praktische Informatik IV
              Universitaet Mannheim
              68131 Mannheim
              Germany
              email: kuehne@informatik.uni-mannheim.de

   (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt

   $Id: ITagStream.h,v 1.1 2004/02/17 12:00:48 kopf Exp $

*/

#ifndef I_TAG_STREAM_H
#define I_TAG_STREAM_H


// C++ includes
#include <string>
#include <fstream>
using namespace std;


class ITagStream : public ifstream
{
public:
    ITagStream();
    ITagStream(const string&);
    ITagStream(const char*);
};

inline
ITagStream::
ITagStream()
        : ifstream()
{}

inline
ITagStream::
ITagStream(const string& uri)
        : ifstream(uri.c_str())
{}

inline
ITagStream::
ITagStream(const char* uri)
        : ifstream(uri)
{}

#endif



