/*
    OMpegMplex.cpp     multiplex audio and video files
	Copyright (C) 2004 Stephan Kopf

	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <OMpegMplex.h>

const string OMpegMplex::WINDOWS_MPLEX_EXECUTABLE = "mplex.exe";
const string OMpegMplex::LINUX_MPLEX_EXECUTABLE   = "mplex";

void 
OMpegMplex::process(string &fileIn1, string &fileIn2, string &fileOut)
{
	string cmd = getCommand();

	// modify filename, if spaces in filename/path exist
	string tmpFilename1=fileIn1;
	string tmpFilename2=fileIn2;
	string tmpFilename3=fileOut;
	FileHandling::convertToValidUnixFilename(tmpFilename1);
	FileHandling::convertToValidUnixFilename(tmpFilename2);
	FileHandling::convertToValidUnixFilename(tmpFilename3);

	string silent = "";
#if 0
	silent = "-v 0 ";
#endif
	// set command
	cmd = cmd + " " + silent + tmpFilename1 + " " + tmpFilename2 + " -o " + tmpFilename3;

	// start process
	system (cmd.c_str());

	return;
} // process
 
