/*
   This file is part of the MoCA video library.
   Name: OPpmVideoFormatStream.h
   Copyright (C) 2004 Stephan Kopf

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: schuster@informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*! \file



   \author    Stephan Kopf

              Lehrstuhl fuer Praktische Informatik IV
              Universitaet Mannheim
              68131 Mannheim
              Germany
              email: schuster@informatik.uni-mannheim.de

   (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt

   $Id: OPpmFormatStream.h,v 1.1 2004/02/17 12:00:48 kopf Exp $

*/

#ifndef O_PPM_VIDEO_FORMAT_STREAM_H
#define O_PPM_VIDEO_FORMAT_STREAM_H

// MoCA includes
#include <GetType.h>
#include <OImageFormatStream.h>
#include <PpmParameter.h>
#include <OVideoFormatStream.h>


/*!
  pgm format specific stream
*/
template<class T>
class OPpmVideoFormatStream : public OVideoFormatStream<T>
{
public:
    //! the default constructor
    OPpmVideoFormatStream(ostream &os, const FormatParameter *fp = NULL) : OImageFormatStream<T>(os), pp(NULL) { open (os, fp); }

    //! the destructor
    ~OPpmVideoFormatStream() 
    { 
      if (pp != NULL) delete pp; 
      pp = NULL;
    }

    //! open format stream
    void open(ostream &, const FormatParameter *);

    //! write an image
    void write(const Image<T> &) throw (MocaException);

private:
    //! local pgm parameter pointer copy thingy
    PpmParameter* pp;
}; // OPpmFormatStream

#include <OPpmVideoFormatStream.cpt>

#endif


