/*
   This file is part of the MoCA video library.
   Name: ForEachAlgos.h
   Copyright (C) 2004 Oliver Schuster

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: schuster@informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*! \file

   Algorithms which can be used in combination with forEach

   \author    Oliver Schuster

              Lehrstuhl fuer Praktische Informatik IV
              Universitaet Mannheim
              68131 Mannheim
              Germany
              email: schuster@informatik.uni-mannheim.de

   (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt

   $Id: ForEachAlgos.h,v 1.1 2004/02/17 12:00:58 kopf Exp $

*/


#ifndef FOR_EACH_ALGOS_H
#define FOR_EACH_ALGOS_H

// Moca includes
#include <GetType.h>

namespace ForEachAlgos {

/*!

  Helperfunction for call to forEach in filter()

 */
template<class T>
inline
void
clearAll(T *t)
{
    *t = 0;
} // clearAll

template<class T>
inline
void
fillMax(T *t)
{
    *t = GetType::getMax(*t);
} // fillMax

} // namespace ForEachAlgos

#endif
