/*
   This file is part of the MoCA video library.
   Name: SadFeature_mmx.c
   Copyright (C) 2004 Stephan Kopf

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: kopf@informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/*! \file

 
  
   \author    Stephan Kopf
   
	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de
	
	 (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt
	 
*/


// compile with linux:
//    this function is linked externally with the win32 (MSVC) compiler: 
//    define SadFeature_mmx.o in ProjectSettings->Link->Object/Library Modules)
#ifndef _WIN32

// MoCA includes
#include <SadFeature_mmx.h>
#include <mmx.h>


long int
processSAD2 (const unsigned char *img1Ptr, const unsigned char *img2Ptr, long int yOffset1, long int yOffset2)
{

    volatile long unsigned int mmxerror=0;
    int blkh=16;
    int dv;
    
    pxor_r2r(mm0,mm0);
	
	for (dv=0; dv<blkh; dv++) {
	  //const unsigned char* p1 = &img1[y0+dv][x0]; 
	  //const unsigned char* p2 = &img2[y1+dv][x1];
	  
	  __asm__ __volatile__ 
	    (
	     "movq   (%0),%%mm1\n\t"
	     "psadbw (%1),%%mm1\n\t"
	     "paddw  %%mm1,%%mm0\n\t"
	     
	     "movq   8(%0),%%mm2\n\t"
	     "psadbw 8(%1),%%mm2\n\t"
	     "paddw  %%mm2,%%mm0\n\t"
	     
	     : : "r" (img1Ptr), "r" (img2Ptr)
	     );

	  img1Ptr += yOffset1;
	  img2Ptr += yOffset2;
	}
	
	movd_r2m(mm0,mmxerror);
	emms();
	
	return mmxerror;
}
#endif

