/*
   This file is part of the MoCA video library.
   Name: GetType.h
   Copyright (C) 2004 Stephan Kopf

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: kopf@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef GET_TYPE_H
#define GET_TYPE_H

// C++ includes
#include <limits.h>
#include <string>
using namespace std;

// MoCA includes
#include <MocaTypes.h>

/*!

  Helper class which returns either the type of a variable as string
  or returns the maximum of a variable.

  Using floats, the functions getMax() and getMin() return the same
  maximum/minimum as long int values.

 */
class GetType
{
public:

    static string getType(uint8 i)
    {
        string temp = "uint8";
        return temp;
    };

    static string getType(uint16 i)
    {
        string temp = "uint16";
        return temp;
    };

    static string getType(uint32 i)
    {
        string temp = "uint32";
        return temp;
    };

    static string getType(uint64 i)
    {
        string temp = "uint64";
        return temp;
    };


    static string getType(int8 i)
    {
        string temp = "int8";
        return temp;
    };

    static string getType(int16 i)
    {
        string temp = "int16";
        return temp;
    };

    static string getType(int32 i)
    {
        string temp = "int32";
        return temp;
    };

    static string getType(int64 i)
    {
        string temp = "int64";
        return temp;
    };


    static string getType(ieee32 i)
    {
        string temp = "ieee32";
        return temp;
    };

    static string getType(ieee64 i)
    {
        string temp = "ieee64";
        return temp;
    };

    static bool isInteger(uint8 i) {
        return true;
    };

    static bool isInteger(uint16 i) {
        return true;
    };

    static bool isInteger(uint32 i) {
        return true;
    };

    static bool isInteger(uint64 i) {
        return true;
    };


    static bool isInteger(int8 i) {
        return true;
    };

    static bool isInteger(int16 i) {
        return true;
    };

    static bool isInteger(int32 i) {
        return true;
    };

    static bool isInteger(int64 i) {
        return true;
    };


    static bool isInteger(ieee32 i) {
        return false;
    };

    static bool isInteger(ieee64 i) {
        return false;
    };

    
    static bool isSigned(uint8 i) {
        return false;
    };

    static bool isSigned(uint16 i) {
        return false;
    };

    static bool isSigned(uint32 i) {
        return false;
    };

    static bool isSigned(uint64 i) {
        return false;
    };


    static bool isSigned(int8 i) {
        return true;
    };

    static bool isSigned(int16 i) {
        return true;
    };

    static bool isSigned(int32 i) {
        return true;
    };

    static bool isSigned(int64 i) {
        return true;
    };


    static bool isSigned(ieee32 i) {
        return true;
    };

    static bool isSigned(ieee64 i) {
        return true;
    };

       
    static uint8 getMax(uint8 i)
    {
        return MOCA_UINT8_MAX;
    };

    static uint16 getMax(uint16 i)
    {
        return MOCA_UINT16_MAX;
    };

    static uint32 getMax(uint32 i)
    {
        return MOCA_UINT32_MAX;
    };

    static uint64 getMax(uint64 i)
    {
        return MOCA_UINT64_MAX;
    };


    static int8 getMax(int8 i)
    {
        return MOCA_INT8_MAX;
    };

    static int16 getMax(int16 i)
    {
        return MOCA_INT16_MAX;
    };

    static int32 getMax(int32 i)
    {
        return MOCA_INT32_MAX;
    };

    static int64 getMax(int64 i)
    {
        return MOCA_INT64_MAX;
    };


    static ieee32 getMax(ieee32 i)
    {
        return MOCA_IEEE32_MAX;
    };

    static ieee64 getMax(ieee64 i)
    {
        return MOCA_IEEE64_MAX;
    };


    static uint8 getMin(uint8 i)
    {
        return 0;
    };

    static uint16 getMin(uint16 i)
    {
        return 0;
    };

    static uint32 getMin(uint32 i)
    {
        return 0;
    };

    static uint64 getMin(uint64 i)
    {
        return 0;
    };


    static int8 getMin(int8 i)
    {
        return MOCA_INT8_MIN;
    };

    static int16 getMin(int16 i)
    {
        return MOCA_INT16_MIN;
    };

    static int32 getMin(int32 i)
    {
        return MOCA_INT32_MIN;
    };

    static int64 getMin(int64 i)
    {
        return MOCA_INT64_MIN;
    };


    static ieee32 getMin(ieee32 i)
    {
        return MOCA_IEEE32_MIN;
    };

    static ieee64 getMin(ieee64 i)
    {
        return MOCA_IEEE64_MIN;
    };

}; // class GetType


#endif
